package com.gxwebsoft.cms.controller;

import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.cms.service.CmsDocsBookService;
import com.gxwebsoft.cms.entity.CmsDocsBook;
import com.gxwebsoft.cms.param.CmsDocsBookParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import com.gxwebsoft.common.system.entity.User;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 书籍记录表控制器
 *
 * @author 科技小王子
 * @since 2024-09-10 20:47:57
 */
@Api(tags = "书籍记录表管理")
@RestController
@RequestMapping("/api/cms/cms-docs-book")
public class CmsDocsBookController extends BaseController {
    @Resource
    private CmsDocsBookService cmsDocsBookService;

    @ApiOperation("分页查询书籍记录表")
    @GetMapping("/page")
    public ApiResult<PageResult<CmsDocsBook>> page(CmsDocsBookParam param) {
        // 使用关联查询
        return success(cmsDocsBookService.pageRel(param));
    }

    @ApiOperation("查询全部书籍记录表")
    @GetMapping()
    public ApiResult<List<CmsDocsBook>> list(CmsDocsBookParam param) {
        PageParam<CmsDocsBook, CmsDocsBookParam> page = new PageParam<>(param);
        page.setDefaultOrder("create_time desc");
        return success(cmsDocsBookService.list(page.getOrderWrapper()));
        // 使用关联查询
        //return success(cmsDocsBookService.listRel(param));
    }

    @PreAuthorize("hasAuthority('cms:cmsDocsBook:list')")
    @OperationLog
    @ApiOperation("根据id查询书籍记录表")
    @GetMapping("/{id}")
    public ApiResult<CmsDocsBook> get(@PathVariable("id") Integer id) {
        return success(cmsDocsBookService.getById(id));
        // 使用关联查询
        //return success(cmsDocsBookService.getByIdRel(id));
    }

    @ApiOperation("添加书籍记录表")
    @PostMapping()
    public ApiResult<?> save(@RequestBody CmsDocsBook cmsDocsBook) {
        if (cmsDocsBookService.save(cmsDocsBook)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @ApiOperation("修改书籍记录表")
    @PutMapping()
    public ApiResult<?> update(@RequestBody CmsDocsBook cmsDocsBook) {
        if (cmsDocsBookService.updateById(cmsDocsBook)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @ApiOperation("删除书籍记录表")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (cmsDocsBookService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @ApiOperation("批量添加书籍记录表")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<CmsDocsBook> list) {
        if (cmsDocsBookService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @ApiOperation("批量修改书籍记录表")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<CmsDocsBook> batchParam) {
        if (batchParam.update(cmsDocsBookService, "book_id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @ApiOperation("批量删除书籍记录表")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (cmsDocsBookService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
